'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]);

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var moment$5 = require('moment');

var Day$2 = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];

var DayPanel$1 = function DayPanel(props) {
  var range = props.range;
      props.startYear;
      var calendarData = props.calendarData,
      rangeDate = props.rangeDate,
      onChange = props.onChange;
  var today = moment$5().format('YYYY-MM-DD');
  var initStart = rangeDate[0] || today;
  var initEnd = rangeDate[1] || today;
  var hourData = creatTimeData(24); // const minuteData = creatTimeData(60)

  var _useState = React.useState(!range ? moment$5(rangeDate).format('YYYY-MM-DD') || today : ''),
      _useState2 = _slicedToArray(_useState, 2),
      pickerDay = _useState2[0],
      setPickerDay = _useState2[1];

  var _useState3 = React.useState([rangeDate[0] || today, rangeDate[1] || today]),
      _useState4 = _slicedToArray(_useState3, 2),
      selected = _useState4[0],
      setSelected = _useState4[1];

  var _useState5 = React.useState(range ? initStart : ''),
      _useState6 = _slicedToArray(_useState5, 2),
      startDay = _useState6[0],
      setStartDay = _useState6[1];

  var _useState7 = React.useState(range ? initEnd : ''),
      _useState8 = _slicedToArray(_useState7, 2),
      endDay = _useState8[0],
      setEndDay = _useState8[1];

  var _useState9 = React.useState(''),
      _useState10 = _slicedToArray(_useState9, 2),
      hoverDay = _useState10[0],
      setHoverDay = _useState10[1];

  var _useState11 = React.useState(range ? moment$5(rangeDate[0]).hours() : moment$5(rangeDate).hours()),
      _useState12 = _slicedToArray(_useState11, 2),
      hour = _useState12[0],
      setHour = _useState12[1];

  var _useState13 = React.useState(range ? moment$5(rangeDate[1]).hours() : moment$5(rangeDate).hours()),
      _useState14 = _slicedToArray(_useState13, 2),
      endHour = _useState14[0],
      setEndHour = _useState14[1]; // const [minute, setMinute] = useState(range?-1:moment(rangeDate).minute())


  var totalHeight = 0;

  var _useState15 = React.useState(totalHeight),
      _useState16 = _slicedToArray(_useState15, 2);
      _useState16[0];
      var setRootHeight = _useState16[1];

  var _useState17 = React.useState(0),
      _useState18 = _slicedToArray(_useState17, 2),
      scrollTop = _useState18[0],
      setScrollTop = _useState18[1];

  var activeMonthStr = '';

  var _useState19 = React.useState(activeMonthStr),
      _useState20 = _slicedToArray(_useState19, 2),
      activeMonth = _useState20[0],
      setActiveMonth = _useState20[1];

  var warpRef = React.useRef();
  var listRef = React.useRef();
  var startRef = React.useRef();
  React.useEffect(function () {
    var sortDate = [startDay, endDay].sort(dateSort$3);
    setSelected(sortDate);
    setHoverDay('');

    if (range) {
      var startStr = moment$5("".concat(startDay, " ").concat(hour), 'YYYY-MM-DD HH').format('YYYY-MM-DD HH:mm');
      var endStr = moment$5("".concat(endDay, " ").concat(endHour), 'YYYY-MM-DD HH').format('YYYY-MM-DD HH:mm');

      var _sortDate = [startStr, endStr].sort(dateSort$3);

      onChange(_sortDate);
    }
  }, [startDay, endDay]);
  React.useEffect(function () {
    if (!range) {
      var dayStr = moment$5("".concat(pickerDay, " ").concat(hour), 'YYYY-MM-DD HH').format('YYYY-MM-DD HH:mm');
      onChange(dayStr);
    } else {
      var startStr = moment$5("".concat(startDay, " ").concat(hour), 'YYYY-MM-DD HH').format('YYYY-MM-DD HH:mm');
      var endStr = moment$5("".concat(endDay, " ").concat(endHour), 'YYYY-MM-DD HH').format('YYYY-MM-DD HH:mm');
      onChange([startStr, endStr]);
    }
  }, [hour, endHour, pickerDay]);
  React.useEffect(function () {
    setRootHeight(totalHeight);
    warpRef.current.scrollTop = startRef.current.parentNode.offsetTop + startRef.current.offsetTop;
    warpRef.current.addEventListener('scroll', function (val) {
      setScrollTop(warpRef.current.scrollTop || 0);
    });
  }, []);
  React.useEffect(function () {
    setActiveMonth(activeMonthStr);
  }, [scrollTop]);

  function handleClick(dayStr) {
    setHoverDay('');

    if (startDay && endDay) {
      setStartDay(dayStr);
      setHour(0);
      setEndDay('');
      setSelected([]);
    }

    if (startDay && !endDay) {
      var sortDate = [startDay, dayStr].sort(dateSort$3);
      setSelected(sortDate); // setStartDay(sortDate[0])

      setEndDay(dayStr);
      setEndHour(0);
    }
  } // function handleTimeClick(num, type) {
  //   let isHour = type === 'Hour'
  //   isHour ? setHour(num) : setMinute(num)
  //   if (startDay && !endDay) { //选择了开始日期
  //     let date = moment(startDay).format('YYYY-MM-DD')
  //     let dayStr = moment(`${date} ${isHour ? num : hour}:${isHour ? minute : num}`).format('YYYY-MM-DD HH:mm')
  //     setStartDay(dayStr)
  //   }
  //   if (startDay && endDay) { //选择了结束日期
  //     let date = moment(endDay).format('YYYY-MM-DD')
  //     let dayStr = moment(`${date} ${isHour ? num : hour}:${isHour ? minute : num}`).format('YYYY-MM-DD HH:mm')
  //     setEndDay(dayStr)
  //   }
  // }
  // function handleOver(dayStr) {
  //   if (startDay && !endDay) {
  //     setHoverDay(dayStr)
  //     setSelected([startDay, dayStr].sort(dateSort))
  //   }
  // }


  function inputStart(val) {
    setStartDay(val);
    setSelected([val, endDay].sort(dateSort$3));
  }

  function inputEnd(val) {
    setEndDay(val);
    setSelected([val, startDay].sort(dateSort$3));
  }

  return /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'hourPicker'
  }, range && /*#__PURE__*/React__default['default'].createElement("div", {
    className: "inputWarp"
  }, /*#__PURE__*/React__default['default'].createElement("input", {
    className: "inputItem date-input__start",
    placeholder: "YYYY-MM-DD",
    maxLength: "10",
    value: startDay && moment$5("".concat(startDay, " ").concat(hour), 'YYYY-MM-DD HH').format('HH:mm,MMM DD,YYYY') || '',
    onChange: function onChange(e) {
      inputStart(e.target.value);
    }
  }), /*#__PURE__*/React__default['default'].createElement("span", {
    className: 'dateDash'
  }, " - "), /*#__PURE__*/React__default['default'].createElement("input", {
    className: "inputItem date-input__end",
    placeholder: "YYYY-MM-DD",
    maxLength: "10",
    value: endDay && moment$5("".concat(endDay, " ").concat(endHour), 'YYYY-MM-DD HH').format('HH:mm,MMM DD,YYYY') || '',
    onChange: function onChange(e) {
      inputEnd(e.target.value);
    }
  })), /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'dayPicker'
  }, /*#__PURE__*/React__default['default'].createElement("div", null, /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'timePicker'
  }, /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'timeSelect'
  }, hourData.map(function (i, index) {
    return /*#__PURE__*/React__default['default'].createElement("div", {
      key: i,
      className: "timeItem ".concat(hour === index ? 'active' : ''),
      onClick: function onClick() {
        setHour(index); // if(range){
        //   if (hour === -1) return
        //   handleTimeClick(index, 'Hour')
        // }else {
        //   setHour(index)
        // }
      }
    }, i, ":00");
  })), range && /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'timeSelect'
  }, hourData.map(function (i, index) {
    return /*#__PURE__*/React__default['default'].createElement("div", {
      key: i,
      className: "timeItem ".concat(endHour === index ? 'active' : ''),
      onClick: function onClick() {
        setEndHour(index); // if(range){
        //   setEndHour(index)
        //   if (minute === -1) return
        //   handleTimeClick(index, 'Minute')
        // }else {
        //   setEndHour(index)
        // }
      }
    }, i, ":00");
  })))), /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'dayPanel hasMonthTitle'
  }, /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'monthTitle'
  }, activeMonth), /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'dayOfWeek'
  }, Day$2.map(function (item) {
    return /*#__PURE__*/React__default['default'].createElement("div", {
      className: 'dayOfWeekName',
      key: item
    }, item);
  })), /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'calendarWarp',
    ref: warpRef
  }, /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'monthListRoot',
    ref: listRef,
    style: {
      height: "".concat(totalHeight, "px")
    }
  }, calendarData.length && calendarData.map(function (year) {
    var height = 0;
    return year.month.map(function (month) {
      height = (month.week.length - 1) * 40;
      totalHeight += height;

      if (month.offsetTop <= scrollTop && scrollTop < month.offsetTop + height) {
        activeMonthStr = moment$5("".concat(year.year, "-").concat(month.month + 1)).format('MMM YYYY');
      }

      return /*#__PURE__*/React__default['default'].createElement("div", {
        key: "".concat(year.year, "-").concat(month.month),
        className: 'monthListItem',
        style: {
          height: "".concat(height, "px"),
          top: "".concat(month.offsetTop, "px")
        }
      }, month.week.map(function (weekItem) {
        var startEl = weekItem.days.some(function (i) {
          return moment$5(i.dayStr).isSame(range ? startDay : pickerDay, "day");
        });
        return /*#__PURE__*/React__default['default'].createElement("div", {
          key: weekItem.weekNum,
          className: 'weekItem',
          ref: startEl ? startRef : null
        }, weekItem.days.map(function (day) {
          var afterToday = !moment$5().isAfter(day.dayStr);
          var active = moment$5(day.dayStr).isSame(startDay, "day") || moment$5(day.dayStr).isSame(endDay, "day") || moment$5(day.dayStr).isSame(hoverDay, "day");
          return /*#__PURE__*/React__default['default'].createElement("div", {
            key: "".concat(year.year, "-").concat(month.month, "-").concat(day.day),
            className: "dayItem\n                                ".concat(!range && moment$5(day.dayStr).isSame(pickerDay, "day") ? 'active' : '', "\n                                ").concat(active ? 'active' : '', "\n                                ").concat(afterToday ? 'disabled' : '', "\n                                ").concat(moment$5(day.dayStr).isBetween(selected[0], selected[1]) ? 'selectBetween' : '', "\n                                "),
            onClick: function onClick() {
              if (range) {
                if (afterToday) return;
                handleClick(day.dayStr);
              } else {
                if (afterToday) return;
                setPickerDay(day.dayStr);
              }
            },
            onMouseOver: function onMouseOver() {// if (afterToday) {
              //   handleOver(today)
              // } else {
              //   handleOver(day.dayStr)
              // }
            }
          }, /*#__PURE__*/React__default['default'].createElement("div", null, day.day));
        }));
      }));
    });
  }))))));
}; // 侧边栏


function dateSort$3(a, b) {
  return Date.parse(a) - Date.parse(b);
}

function creatTimeData(number) {
  var data = [];

  for (var i = 0; i < number; i++) {
    data.push(pad(i, 2));
  }

  function pad(num, n) {
    return (Array(n).join(0) + num).slice(-n);
  }

  return data;
}

var moment$4 = require('moment');

var Day$1 = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
var WeekPanel = (function (props) {
  var startYear = props.startYear,
      range = props.range,
      onChange = props.onChange,
      rangeDate = props.rangeDate,
      calendarData = props.calendarData;
  var today = moment$4().format('YYYY-MM-DD');
  var initStart = rangeDate[0] || today;
  var initEnd = rangeDate[1] || today;
  var empty = [];

  for (var i = 0; i < moment$4("".concat(startYear, "-1-1")).day(); i++) {
    empty.push('');
  }

  var _useState = React.useState(getWeekByDate(rangeDate || today)),
      _useState2 = _slicedToArray(_useState, 2),
      pickerWeek = _useState2[0],
      setPickerWeek = _useState2[1];

  var _useState3 = React.useState(getInterval(getWeekByDate(initStart), getWeekByDate(initEnd))),
      _useState4 = _slicedToArray(_useState3, 2),
      selected = _useState4[0],
      setSelected = _useState4[1];

  var _useState5 = React.useState(range ? getWeekByDate(initStart) : []),
      _useState6 = _slicedToArray(_useState5, 2),
      startWeek = _useState6[0],
      setStartWeek = _useState6[1];

  var _useState7 = React.useState(range ? getWeekByDate(initEnd) : []),
      _useState8 = _slicedToArray(_useState7, 2),
      endWeek = _useState8[0],
      setEndWeek = _useState8[1];

  var _useState9 = React.useState([]),
      _useState10 = _slicedToArray(_useState9, 2),
      hoverWeek = _useState10[0],
      setHoverWeek = _useState10[1];

  var _useState11 = React.useState(false),
      _useState12 = _slicedToArray(_useState11, 2),
      clearActive = _useState12[0],
      setClearActive = _useState12[1];

  var warpRef = React.useRef();
  var listRef = React.useRef();
  var startRef = React.useRef();
  React.useEffect(function () {
    warpRef.current.scrollTop = startRef.current.offsetTop - 5;
  }, [rangeDate]);
  React.useEffect(function () {
    setSelected(getInterval(startWeek, endWeek));
    setHoverWeek([]);

    if (range) {
      onChange([startWeek[0], endWeek[1]]);
    } else {
      onChange(pickerWeek[0]);
    }
  }, [startWeek, endWeek, pickerWeek]);

  function handleClick(dayStr) {
    setHoverWeek([]);

    if (startWeek.length && endWeek.length) {
      setStartWeek(getWeekByDate(dayStr));
      setEndWeek([]);
      setClearActive(true);
    }

    if (startWeek.length && !endWeek.length) {
      var end = getWeekByDate(dayStr);

      if (moment$4(end[1]).isBefore(startWeek[0])) {
        setStartWeek(end);
        setEndWeek(startWeek);
      }

      if (moment$4(end[0]).isAfter(startWeek[1])) {
        setEndWeek(end);
        setSelected(getInterval(startWeek, end));
      }

      setClearActive(false);
    }
  }

  function handleOver(dayStr) {
    if (startWeek.length && !endWeek.length) {
      var _hoverWeek = getWeekByDate(dayStr);

      setHoverWeek(_hoverWeek);
      setSelected(getInterval(startWeek, _hoverWeek));
    }
  }

  function inputStart(val) {
    setStartWeek(getWeekByDate(val));
    setSelected(getInterval(getWeekByDate(val), endWeek));
  }

  function inputEnd(val) {
    setEndWeek(getWeekByDate(val));
    setSelected(getInterval(startWeek, getWeekByDate(val)));
  }

  function setLast() {
    warpRef.current.scrollTop = listRef.current.offsetHeight - warpRef.current.offsetHeight;
  }

  return /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'dayPicker'
  }, range && /*#__PURE__*/React__default['default'].createElement(Sidebar$2, {
    setStartDay: setStartWeek,
    setEndDay: setEndWeek,
    clearActive: clearActive,
    setLast: setLast
  }), /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'dayPanel'
  }, range && /*#__PURE__*/React__default['default'].createElement("div", {
    className: "inputWarp"
  }, /*#__PURE__*/React__default['default'].createElement("input", {
    className: "inputItem date-input__start",
    placeholder: "YYYY-MM-DD",
    maxLength: "10",
    value: startWeek[0] || '',
    onChange: function onChange(e) {
      inputStart(e.target.value);
    }
  }), /*#__PURE__*/React__default['default'].createElement("span", null, " - "), /*#__PURE__*/React__default['default'].createElement("input", {
    className: "inputItem date-input__end",
    placeholder: "YYYY-MM-DD",
    maxLength: "10",
    value: endWeek[1] || '',
    onChange: function onChange(e) {
      inputEnd(e.target.value);
    }
  })), /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'dayOfWeek'
  }, Day$1.map(function (item) {
    return /*#__PURE__*/React__default['default'].createElement("div", {
      className: 'dayOfWeekName',
      key: item
    }, item);
  })), /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'calendarWarp',
    ref: warpRef
  }, /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'dayList',
    ref: listRef
  }, empty.map(function (i, index) {
    return /*#__PURE__*/React__default['default'].createElement("div", {
      className: 'dayItem emptyItem',
      key: index
    });
  }), calendarData.map(function (year) {
    return year.month.map(function (month) {
      return month.day.map(function (day) {
        var startEl = moment$4(day.dayStr).isSame(range ? startWeek[0] : pickerWeek[0], "day");
        var afterToday = !moment$4().isAfter(day.dayStr);
        var active = !range && (moment$4(day.dayStr).isBetween(pickerWeek[0], pickerWeek[1]) || day.dayStr === pickerWeek[0] || day.dayStr === pickerWeek[1]);
        var startActive = range && (moment$4(day.dayStr).isBetween(startWeek[0], startWeek[1]) || day.dayStr === startWeek[0] || day.dayStr === startWeek[1]);
        var endActive = range && (moment$4(day.dayStr).isBetween(endWeek[0], endWeek[1]) || day.dayStr === endWeek[0] || day.dayStr === endWeek[1]);
        var hoverActive = range && (moment$4(day.dayStr).isBetween(hoverWeek[0], hoverWeek[1]) || day.dayStr === hoverWeek[0] || day.dayStr === hoverWeek[1]);
        var selectBetween = selected.length && moment$4(day.dayStr).isBetween(selected[0], selected[1]);
        var leftActive = day.dayStr === pickerWeek[0] || day.dayStr === startWeek[0] || day.dayStr === endWeek[0] || day.dayStr === hoverWeek[0];
        var rightActive = day.dayStr === pickerWeek[1] || day.dayStr === startWeek[1] || day.dayStr === endWeek[1] || day.dayStr === hoverWeek[1];
        return /*#__PURE__*/React__default['default'].createElement("div", {
          ref: startEl ? startRef : null,
          key: "".concat(year.year, "-").concat(month.month, "-").concat(day.day),
          className: "dayItem\n                     ".concat(month.month % 2 === 0 ? 'monthOdd' : '', "\n                     ").concat(active || startActive || endActive || hoverActive ? 'active weekActive' : '', "\n                     ").concat(afterToday ? 'disabled' : '', "\n                     ").concat(leftActive ? 'leftActive' : '', "\n                     ").concat(rightActive ? 'rightActive' : '', "\n                     ").concat(selectBetween ? 'selectBetween' : '', "\n                     "),
          onClick: function onClick() {
            if (range) {
              if (afterToday) return;
              handleClick(day.dayStr);
            } else {
              if (afterToday) return;
              setPickerWeek(getWeekByDate(day.dayStr));
              onChange(getWeekByDate(day.dayStr));
            }
          },
          onMouseOver: function onMouseOver() {
            if (range) {
              if (afterToday) {
                handleOver(today);
              } else {
                handleOver(day.dayStr);
              }
            }
          }
        }, /*#__PURE__*/React__default['default'].createElement("div", null, day.day));
      });
    });
  })))));
}); // 侧边栏

function Sidebar$2(props) {
  var setStartDay = props.setStartDay,
      setEndDay = props.setEndDay,
      clearActive = props.clearActive,
      setLast = props.setLast;

  var _useState13 = React.useState(''),
      _useState14 = _slicedToArray(_useState13, 2),
      active = _useState14[0],
      setActice = _useState14[1];

  React.useEffect(function () {
    clearActive && setActice('');
  }, [clearActive]);
  var year = moment$4().year();
  var option = [{
    tabName: 'Last 4 Weeks',
    startDay: getWeekByDate(moment$4().subtract(21, 'days').format('YYYY-MM-DD'))
  }, {
    tabName: 'Last 12 Weeks',
    startDay: getWeekByDate(moment$4().subtract(77, 'days').format('YYYY-MM-DD'))
  }, {
    tabName: 'Last 24 Weeks',
    startDay: getWeekByDate(moment$4().subtract(161, 'days').format('YYYY-MM-DD'))
  }, {
    tabName: 'Year to Date',
    startDay: getWeekByDate(moment$4("".concat(year, "-1-1")).format('YYYY-MM-DD'))
  }];
  return /*#__PURE__*/React__default['default'].createElement("div", null, /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'sidebarWarp'
  }, option.map(function (item) {
    return /*#__PURE__*/React__default['default'].createElement("div", {
      className: "sideItem\n            ".concat(active === item.tabName ? 'sideActive' : '', "\n            "),
      key: item.tabName,
      onClick: function onClick() {
        setLast();
        setActice(item.tabName);
        setStartDay(item.startDay);
        setEndDay(getWeekByDate(moment$4().format('YYYY-MM-DD')));
      }
    }, item.tabName);
  })));
}

function getWeekByDate(date) {
  var start = moment$4(date).weekday(0).format('YYYY-MM-DD'); //本周一

  var end = moment$4(date).weekday(6).format('YYYY-MM-DD'); //本周日

  return [start, end];
}

function getInterval(startWeek, endWeek) {
  if (moment$4(endWeek[1]).isBefore(startWeek[0])) {
    return [endWeek[1], startWeek[0]];
  }

  if (moment$4(endWeek[0]).isAfter(startWeek[1])) {
    return [startWeek[1], endWeek[0]];
  }

  return startWeek || endWeek;
}

var moment$3 = require('moment');

var MonthPanel = (function (props) {
  var startYear = props.startYear,
      range = props.range,
      onChange = props.onChange,
      rangeDate = props.rangeDate;
  var currentMonth = moment$3().format('YYYY-MM');
  var year = moment$3().year();
  var initStart = moment$3(rangeDate[0]).format('YYYY-MM') || currentMonth;
  var initEnd = moment$3(rangeDate[1]).format('YYYY-MM') || currentMonth;
  var calendarData = creatCalendar$1(startYear, year);

  var _useState = React.useState(!range ? moment$3(rangeDate).format('YYYY-MM') || currentMonth : ''),
      _useState2 = _slicedToArray(_useState, 2),
      pickerMonth = _useState2[0],
      setPickerMonth = _useState2[1];

  var _useState3 = React.useState([initStart, initEnd]),
      _useState4 = _slicedToArray(_useState3, 2),
      selected = _useState4[0],
      setSelected = _useState4[1];

  var _useState5 = React.useState(range ? initStart : ''),
      _useState6 = _slicedToArray(_useState5, 2),
      startMonth = _useState6[0],
      setStartMonth = _useState6[1];

  var _useState7 = React.useState(range ? initEnd : ''),
      _useState8 = _slicedToArray(_useState7, 2),
      endMonth = _useState8[0],
      setEndMonth = _useState8[1];

  var _useState9 = React.useState(''),
      _useState10 = _slicedToArray(_useState9, 2),
      hoverMonth = _useState10[0],
      setHoverMonth = _useState10[1];

  var _useState11 = React.useState(false),
      _useState12 = _slicedToArray(_useState11, 2),
      clearActive = _useState12[0],
      setClearActive = _useState12[1];

  var warpRef = React.useRef();
  var listRef = React.useRef();
  var startRef = React.useRef();
  React.useEffect(function () {
    warpRef.current.scrollTop = startRef.current.offsetTop - 5;
  }, [rangeDate]);
  React.useEffect(function () {
    var sortDate = [startMonth, endMonth].sort(dateSort$2);
    setSelected(sortDate);
    onChange(sortDate);
    setHoverMonth('');
  }, [startMonth, endMonth]);

  function handleClick(dayStr) {
    setHoverMonth('');

    if (startMonth && endMonth) {
      setStartMonth(dayStr);
      setEndMonth('');
      setSelected([]);
      setClearActive(true);
    }

    if (startMonth && !endMonth) {
      var sortDate = [startMonth, dayStr].sort(dateSort$2);
      setSelected(sortDate);
      setStartMonth(sortDate[0]);
      setEndMonth(sortDate[1]);
      setClearActive(false);
    }
  }

  function handleOver(dayStr) {
    if (startMonth && !endMonth) {
      setHoverMonth(dayStr);
      setSelected([startMonth, dayStr].sort(dateSort$2));
    }
  }

  function setLast() {
    warpRef.current.scrollTop = listRef.current.offsetHeight - warpRef.current.offsetHeight;
  }

  return /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'dayPicker'
  }, range && /*#__PURE__*/React__default['default'].createElement(Sidebar$1, {
    setStartDay: setStartMonth,
    setEndDay: setEndMonth,
    clearActive: clearActive,
    setLast: setLast
  }), /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'dayPanel'
  }, range && /*#__PURE__*/React__default['default'].createElement("div", {
    className: "inputWarp"
  }, /*#__PURE__*/React__default['default'].createElement("input", {
    className: "inputItem date-input__start",
    placeholder: "YYYY-MM-DD",
    maxLength: "10",
    value: startMonth || '',
    onChange: function onChange(e) {}
  }), /*#__PURE__*/React__default['default'].createElement("span", null, " - "), /*#__PURE__*/React__default['default'].createElement("input", {
    className: "inputItem date-input__end",
    placeholder: "YYYY-MM-DD",
    maxLength: "10",
    value: endMonth || '',
    onChange: function onChange(e) {}
  })), /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'MonthCalendarWarp calendarWarp',
    ref: warpRef
  }, /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'monthList',
    ref: listRef
  }, calendarData.map(function (year) {
    return /*#__PURE__*/React__default['default'].createElement("div", {
      className: 'yearItem',
      key: year.year
    }, /*#__PURE__*/React__default['default'].createElement("div", {
      className: 'yearName'
    }, year.year), /*#__PURE__*/React__default['default'].createElement("div", {
      className: 'monthBox'
    }, year.month.map(function (month) {
      var startEl = moment$3(month.monthDate).isSame(range ? startMonth : pickerMonth, 'month');
      var afterToday = !moment$3().isSameOrAfter(month.monthDate, 'month');
      var startActive = range && moment$3(month.monthDate).isSame(startMonth, 'month');
      var endActive = range && moment$3(month.monthDate).isSame(endMonth, 'month');
      var hoverActive = range && moment$3(month.monthDate).isSame(hoverMonth, 'month');
      var selectBetween = moment$3(month.monthDate).isBetween(selected[0], selected[1], 'month');
      return /*#__PURE__*/React__default['default'].createElement("div", {
        ref: startEl ? startRef : null,
        key: month.monthDate,
        className: "monthItem\n                          ".concat(!range && month.monthDate === pickerMonth ? 'active' : '', "\n                          ").concat(startActive || endActive || hoverActive ? 'active' : '', "\n                          ").concat(afterToday ? 'disabled' : '', "\n                          ").concat(selectBetween ? 'selectBetween' : '', "\n\n                        "),
        onClick: function onClick() {
          if (range) {
            if (afterToday) return;
            handleClick(month.monthDate);
          } else {
            if (afterToday) return;
            setPickerMonth(month.monthDate);
            onChange(month.monthDate);
          }
        },
        onMouseOver: function onMouseOver() {
          if (range) {
            if (afterToday) {
              handleOver(currentMonth);
            } else {
              handleOver(month.monthDate);
            }
          }
        }
      }, month.month);
    })));
  })))));
}); // 侧边栏

function Sidebar$1(props) {
  var setStartDay = props.setStartDay,
      setEndDay = props.setEndDay,
      clearActive = props.clearActive,
      setLast = props.setLast;

  var _useState13 = React.useState(''),
      _useState14 = _slicedToArray(_useState13, 2),
      active = _useState14[0],
      setActive = _useState14[1];

  React.useEffect(function () {
    clearActive && setActive('');
  }, [clearActive]);
  var year = moment$3().year();
  var option = [{
    tabName: 'Last 3 Months',
    startDay: moment$3().subtract(2, 'months').format('YYYY-MM')
  }, {
    tabName: 'Last 6 Months',
    startDay: moment$3().subtract(5, 'months').format('YYYY-MM')
  }, {
    tabName: 'Last 12 Months',
    startDay: moment$3().subtract(11, 'months').format('YYYY-MM')
  }, {
    tabName: 'Last 24 Months',
    startDay: moment$3().subtract(23, 'months').format('YYYY-MM')
  }, {
    tabName: 'Year to Date',
    startDay: moment$3("".concat(year, "-1")).format('YYYY-MM')
  }];
  return /*#__PURE__*/React__default['default'].createElement("div", null, /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'sidebarWarp'
  }, option.map(function (item) {
    return /*#__PURE__*/React__default['default'].createElement("div", {
      className: "sideItem\n            ".concat(active === item.tabName ? 'sideActive' : '', "\n            "),
      key: item.tabName,
      onClick: function onClick() {
        setLast();
        setActive(item.tabName);
        setStartDay(item.startDay);
        setEndDay(moment$3().format('YYYY-MM'));
      }
    }, item.tabName);
  })));
}

function creatCalendar$1(startYear, year) {
  var daysArr = [];

  for (var i = 0; i <= year - startYear; i++) {
    daysArr.push({
      year: startYear + i,
      month: []
    });

    for (var j = 0; j < 12; j++) {
      daysArr[i]['month'].push({
        month: moment$3("".concat(daysArr[i].year, "-").concat(j + 1)).format('MMM'),
        monthDate: moment$3("".concat(daysArr[i].year, "-").concat(j + 1)).format('YYYY-MM')
      });
    }
  }

  return daysArr;
} // 排序函数


function dateSort$2(a, b) {
  return Date.parse(a) - Date.parse(b);
}

var moment$2 = require('moment');

var Day = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];

var DayPanel = function DayPanel(props) {
  var range = props.range;
      props.startYear;
      var calendarData = props.calendarData,
      rangeDate = props.rangeDate,
      onChange = props.onChange;
  var today = moment$2().format('YYYY-MM-DD');
  var initStart = moment$2(rangeDate[0]).format('YYYY-MM-DD') || today;
  var initEnd = moment$2(rangeDate[1]).format('YYYY-MM-DD') || today;

  var _useState = React.useState(!range ? rangeDate || today : ''),
      _useState2 = _slicedToArray(_useState, 2),
      pickerDay = _useState2[0],
      setPickerDay = _useState2[1];

  var _useState3 = React.useState([rangeDate[0] || today, rangeDate[1] || today]),
      _useState4 = _slicedToArray(_useState3, 2),
      selected = _useState4[0],
      setSelected = _useState4[1];

  var _useState5 = React.useState(range ? initStart : ''),
      _useState6 = _slicedToArray(_useState5, 2),
      startDay = _useState6[0],
      setStartDay = _useState6[1];

  var _useState7 = React.useState(range ? initEnd : ''),
      _useState8 = _slicedToArray(_useState7, 2),
      endDay = _useState8[0],
      setEndDay = _useState8[1];

  var _useState9 = React.useState(''),
      _useState10 = _slicedToArray(_useState9, 2),
      hoverDay = _useState10[0],
      setHoverDay = _useState10[1];

  var _useState11 = React.useState(false),
      _useState12 = _slicedToArray(_useState11, 2),
      clearActive = _useState12[0],
      setClearActive = _useState12[1];

  var totalHeight = 0;

  var _useState13 = React.useState(totalHeight),
      _useState14 = _slicedToArray(_useState13, 2),
      rootHeight = _useState14[0],
      setRootHeight = _useState14[1];

  var _useState15 = React.useState(0),
      _useState16 = _slicedToArray(_useState15, 2),
      scrollTop = _useState16[0],
      setScrollTop = _useState16[1];

  var activeMonthStr = '';

  var _useState17 = React.useState(activeMonthStr),
      _useState18 = _slicedToArray(_useState17, 2),
      activeMonth = _useState18[0],
      setActiveMonth = _useState18[1];

  var warpRef = React.useRef();
  var listRef = React.useRef();
  var startRef = React.useRef();
  React.useEffect(function () {
    if (range) {
      var sortDate = [startDay, endDay].sort(dateSort$1);
      setSelected(sortDate);
      setHoverDay('');
      onChange(sortDate);
    } else {
      onChange(pickerDay);
    }
  }, [startDay, endDay, pickerDay]);
  React.useEffect(function () {
    setRootHeight(totalHeight);
    warpRef.current.scrollTop = startRef.current.parentNode.offsetTop + startRef.current.offsetTop;
    warpRef.current.addEventListener('scroll', function (val) {
      setScrollTop(warpRef.current.scrollTop || 0);
    });
  }, []);
  React.useEffect(function () {
    setActiveMonth(activeMonthStr);
  }, [scrollTop]);

  function handleClick(dayStr) {
    setHoverDay('');

    if (startDay && endDay) {
      setStartDay(dayStr);
      setEndDay('');
      setSelected([]);
      setClearActive(true);
    }

    if (startDay && !endDay) {
      var sortDate = [startDay, dayStr].sort(dateSort$1);
      setSelected(sortDate);
      setStartDay(sortDate[0]);
      setEndDay(sortDate[1]);
      setClearActive(false);
    }
  }

  function inputStart(val) {
    setStartDay(val);
    setSelected([val, endDay].sort(dateSort$1));
  }

  function inputEnd(val) {
    setEndDay(val);
    setSelected([val, startDay].sort(dateSort$1));
  }

  function setLast() {
    warpRef.current.scrollTop = rootHeight - warpRef.current.offsetHeight;
  }

  return /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'dayPicker'
  }, range && /*#__PURE__*/React__default['default'].createElement(Sidebar, {
    setStartDay: setStartDay,
    setEndDay: setEndDay,
    clearActive: clearActive,
    setLast: setLast
  }), /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'dayPanel hasMonthTitle'
  }, range && /*#__PURE__*/React__default['default'].createElement("div", {
    className: "inputWarp"
  }, /*#__PURE__*/React__default['default'].createElement("input", {
    className: "inputItem date-input__start",
    placeholder: "YYYY-MM-DD",
    maxLength: "10",
    value: startDay || '',
    onChange: function onChange(e) {
      inputStart(e.target.value);
    }
  }), /*#__PURE__*/React__default['default'].createElement("span", {
    className: 'dateDash'
  }, " - "), /*#__PURE__*/React__default['default'].createElement("input", {
    className: "inputItem date-input__end",
    placeholder: "YYYY-MM-DD",
    maxLength: "10",
    value: endDay || '',
    onChange: function onChange(e) {
      inputEnd(e.target.value);
    }
  })), /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'monthTitle'
  }, activeMonth), /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'dayOfWeek'
  }, Day.map(function (item) {
    return /*#__PURE__*/React__default['default'].createElement("div", {
      className: 'dayOfWeekName',
      key: item
    }, item);
  })), /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'calendarWarp',
    ref: warpRef
  }, /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'monthListRoot',
    ref: listRef,
    style: {
      height: "".concat(totalHeight, "px")
    }
  }, calendarData.length && calendarData.map(function (year) {
    var height = 0;
    return year.month.map(function (month) {
      height = (month.week.length - 1) * 40;
      totalHeight += height;

      if (month.offsetTop <= scrollTop && scrollTop < month.offsetTop + height) {
        activeMonthStr = moment$2("".concat(year.year, "-").concat(month.month + 1)).format('MMM YYYY');
      }

      return /*#__PURE__*/React__default['default'].createElement("div", {
        key: "".concat(year.year, "-").concat(month.month),
        className: 'monthListItem',
        style: {
          height: "".concat(height, "px"),
          top: "".concat(month.offsetTop, "px")
        }
      }, month.week.map(function (weekItem) {
        var startEl = weekItem.days.some(function (i) {
          return moment$2(i.dayStr).isSame(range ? startDay : pickerDay, "day");
        });
        return /*#__PURE__*/React__default['default'].createElement("div", {
          key: weekItem.weekNum,
          className: 'weekItem',
          ref: startEl ? startRef : null
        }, weekItem.days.map(function (day) {
          var afterToday = !moment$2().isAfter(day.dayStr);
          var active = moment$2(day.dayStr).isSame(startDay, "day") || moment$2(day.dayStr).isSame(endDay, "day") || moment$2(day.dayStr).isSame(hoverDay, "day");
          return /*#__PURE__*/React__default['default'].createElement("div", {
            key: "".concat(year.year, "-").concat(month.month, "-").concat(day.day),
            className: "dayItem\n                                ".concat(active ? 'active' : '', "\n                                ").concat(!range && moment$2(day.dayStr).isSame(pickerDay, "day") ? 'active' : '', "\n                                ").concat(afterToday ? 'disabled' : '', "\n                                ").concat(moment$2(day.dayStr).isBetween(selected[0], selected[1]) ? 'selectBetween' : '', "\n                                "),
            onClick: function onClick() {
              if (range) {
                if (afterToday) return;
                handleClick(day.dayStr);
              } else {
                if (afterToday) return;
                setPickerDay(day.dayStr);
              }
            },
            onMouseOver: function onMouseOver() {// if (afterToday) {
              //   handleOver(today)
              // } else {
              //   handleOver(day.dayStr)
              // }
            }
          }, /*#__PURE__*/React__default['default'].createElement("div", null, day.day));
        }));
      }));
    });
  })))));
}; // 侧边栏


function Sidebar(props) {
  var setStartDay = props.setStartDay,
      setEndDay = props.setEndDay,
      clearActive = props.clearActive,
      setLast = props.setLast;

  var _useState19 = React.useState(''),
      _useState20 = _slicedToArray(_useState19, 2),
      active = _useState20[0],
      setActive = _useState20[1];

  React.useEffect(function () {
    clearActive && setActive('');
  }, [clearActive]);
  var year = moment$2().year();
  var option = [{
    tabName: 'Last 7 Days',
    startDay: moment$2().subtract(6, 'days').format('YYYY-MM-DD')
  }, {
    tabName: 'Last 30 Days',
    startDay: moment$2().subtract(29, 'days').format('YYYY-MM-DD')
  }, {
    tabName: 'Last 90 Days',
    startDay: moment$2().subtract(89, 'days').format('YYYY-MM-DD')
  }, {
    tabName: 'Last 180 Days',
    startDay: moment$2().subtract(179, 'days').format('YYYY-MM-DD')
  }, {
    tabName: 'Last 365 Days',
    startDay: moment$2().subtract(364, 'days').format('YYYY-MM-DD')
  }, {
    tabName: 'Year to Date',
    startDay: moment$2("".concat(year, "-1-1")).format('YYYY-MM-DD')
  }];
  return /*#__PURE__*/React__default['default'].createElement("div", null, /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'sidebarWarp'
  }, option.map(function (item) {
    return /*#__PURE__*/React__default['default'].createElement("div", {
      className: "sideItem\n            ".concat(active === item.tabName ? 'sideActive' : '', "\n            "),
      key: item.tabName,
      onClick: function onClick() {
        setLast();
        setActive(item.tabName);
        setStartDay(item.startDay);
        setEndDay(moment$2().format('YYYY-MM-DD'));
      }
    }, item.tabName);
  })));
} // 排序函数


function dateSort$1(a, b) {
  return Date.parse(a) - Date.parse(b);
}

var moment$1 = require('moment');

var tabOption = [{
  tabName: 'Hour'
}, {
  tabName: 'Day'
}, {
  tabName: 'Week'
}, {
  tabName: 'Month'
}];

var Calendar = function Calendar(props) {
  var range = props.range,
      rangeDate = props.rangeDate,
      rangeType = props.rangeType,
      setRangeType = props.setRangeType,
      setRangeDate = props.setRangeDate,
      setShow = props.setShow,
      _props$startYear = props.startYear,
      startYear = _props$startYear === void 0 ? 2020 : _props$startYear;

  var _useState = React.useState(rangeType),
      _useState2 = _slicedToArray(_useState, 2),
      tab = _useState2[0],
      setTab = _useState2[1];

  var _useState3 = React.useState([]),
      _useState4 = _slicedToArray(_useState3, 2),
      selectDate = _useState4[0],
      setSelectDate = _useState4[1];

  var year = moment$1().year();
  var calendarData = creatCalendar(startYear, year);
  var calendarData2 = creatCalendar2(startYear, year);
  return /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'datePickerWarp'
  }, /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'pickerHeader'
  }, /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'tabBox'
  }, tabOption.map(function (item) {
    return /*#__PURE__*/React__default['default'].createElement("div", {
      className: "tabItem ".concat(item.tabName === tab ? 'tabActive' : null),
      key: item.tabName,
      onClick: function onClick() {
        setTab(item.tabName);
        setRangeType(item.tabName);
      }
    }, item.tabName);
  }))), tab === 'Hour' && /*#__PURE__*/React__default['default'].createElement(DayPanel$1, {
    range: range,
    calendarData: calendarData2 || [],
    startYear: startYear,
    rangeDate: rangeDate,
    onChange: function onChange(val) {
      var date = range ? val.sort(dateSort) : val;
      setSelectDate(date);
    }
  }), tab === 'Day' && /*#__PURE__*/React__default['default'].createElement(DayPanel, {
    range: range,
    calendarData: calendarData2 || [],
    startYear: startYear,
    rangeDate: rangeDate,
    onChange: function onChange(val) {
      setSelectDate(val);
    }
  }), tab === 'Week' && /*#__PURE__*/React__default['default'].createElement(WeekPanel, {
    range: range,
    calendarData: calendarData || [],
    startYear: startYear,
    rangeDate: rangeDate,
    onChange: function onChange(val) {
      setSelectDate(val);
    }
  }), tab === 'Month' && /*#__PURE__*/React__default['default'].createElement(MonthPanel, {
    range: range,
    startYear: startYear,
    rangeDate: rangeDate,
    onChange: function onChange(val) {
      setSelectDate(val);
    }
  }), /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'pickerFooter'
  }, /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'confirmBtn',
    onClick: function onClick(e) {
      setRangeDate(selectDate);
      setShow(false);
    }
  }, "Confirm"), /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'cancelBtn',
    onClick: function onClick(e) {
      setShow(false);
    }
  }, "Cancel"))));
}; //生成日历数据


function creatCalendar(startYear, year) {
  var daysArr = [];

  for (var i = 0; i <= year - startYear; i++) {
    daysArr.push({
      year: startYear + i,
      month: []
    });

    for (var j = 0; j < 12; j++) {
      daysArr[i]['month'].push({
        month: j,
        day: []
      });
      var len = moment$1("".concat(daysArr[i].year, "-").concat(j + 1), "YYYY-MM").daysInMonth();

      for (var k = 0; k < len; k++) {
        daysArr[i]['month'][j]['day'].push({
          day: k + 1,
          dayStr: moment$1("".concat(startYear + i, "-").concat(j + 1, "-").concat(k + 1)).format('YYYY-MM-DD')
        });
      }

      if (i === year - startYear && j === moment$1().month()) {
        break;
      }
    }
  }

  return daysArr;
}

function creatCalendar2(startYear, year) {
  var daysArr = [];
  var offsetTop = 0;

  for (var i = 0; i <= year - startYear; i++) {
    daysArr.push({
      year: startYear + i,
      month: []
    });

    for (var j = 0; j < 12; j++) {
      daysArr[i]['month'].push({
        month: j,
        week: [{
          weekNum: '',
          days: []
        }, {
          weekNum: '',
          days: []
        }],
        offsetTop: offsetTop
      });
      var weekday = moment$1("".concat(daysArr[i].year, "-").concat(j + 1, "-1"), 'YYYY-MM-DD').weekday();
      var len = moment$1("".concat(daysArr[i].year, "-").concat(j + 1), "YYYY-MM").daysInMonth();
      var weekNum = 1;

      for (var k = 0; k < len; k++) {
        var dayStr = moment$1("".concat(startYear + i, "-").concat(j + 1, "-").concat(k + 1)).format('YYYY-MM-DD');

        if (k <= 6 - weekday) {
          var weekNumofYear = daysArr[i]['month'][j]['week'][0]['weekNum'];
          if (!weekNumofYear) daysArr[i]['month'][j]['week'][0]['weekNum'] = startYear + i + '-' + moment$1(dayStr).week();
          daysArr[i]['month'][j]['week'][0]['days'].push({
            day: k + 1,
            dayStr: dayStr
          });
        } else {
          var _weekNumofYear = daysArr[i]['month'][j]['week'][weekNum]['weekNum'];
          if (!_weekNumofYear) daysArr[i]['month'][j]['week'][weekNum]['weekNum'] = startYear + i + '-' + moment$1(dayStr).week();
          daysArr[i]['month'][j]['week'][weekNum]['days'].push({
            day: k + 1,
            dayStr: dayStr
          });

          if ((k + 1) % 7 === (weekday === 0 ? 0 : 7 - weekday)) {
            weekNum++;
            daysArr[i]['month'][j]['week'][weekNum] = {
              weekNum: '',
              days: []
            };
          }
        }
      }

      offsetTop += (daysArr[i]['month'][j]['week'].length - 1) * 40;
      daysArr[i]['month']['offsetTop'] = offsetTop;

      if (i === year - startYear && j === moment$1().month()) {
        break;
      }
    }
  }

  return daysArr;
}

function dateSort(a, b) {
  return Date.parse(a) - Date.parse(b);
}

var moment = require('moment');

var RangePicker = function RangePicker(props) {
  var startYear = props.startYear,
      range = props.range;

  var _useState = React.useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      show = _useState2[0],
      setShow = _useState2[1];

  var _useState3 = React.useState(range ? [] : moment()),
      _useState4 = _slicedToArray(_useState3, 2),
      rangeDate = _useState4[0],
      setRangeDate = _useState4[1];

  var _useState5 = React.useState('Day'),
      _useState6 = _slicedToArray(_useState5, 2),
      rangeType = _useState6[0],
      setRangeType = _useState6[1];

  var _useState7 = React.useState('MMM DD,YYYY'),
      _useState8 = _slicedToArray(_useState7, 2),
      formatStr = _useState8[0],
      setFormatStr = _useState8[1];

  React.useEffect(function () {
    document.addEventListener("click", function (e) {
      return setShow(false);
    });
  }, []);

  var stopPropagation = function stopPropagation(e) {
    if (!['confirmBtn', 'cancelBtn'].includes(e.target.className)) {
      e.stopPropagation();
    }
  };

  React.useEffect(function () {
    setRangeDate(range ? [] : moment());
  }, [range]);
  React.useEffect(function () {
    if (rangeType === 'Month') {
      setFormatStr('MMM,YYYY');
    } else if (rangeType === 'Hour') {
      setFormatStr('HH:mm,MMM DD,YYYY');
    } else {
      setFormatStr('MMM DD,YYYY');
    }
  }, [rangeType]);
  return /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'rangePicker',
    onClick: function onClick(e) {
      stopPropagation(e);
      setShow(true);
    }
  }, range ? /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'rangeDate'
  }, /*#__PURE__*/React__default['default'].createElement("span", {
    className: 'inputDate'
  }, moment(rangeDate[0]).format(formatStr)), /*#__PURE__*/React__default['default'].createElement("span", {
    className: 'dateDash'
  }, "~"), /*#__PURE__*/React__default['default'].createElement("span", {
    className: 'inputDate'
  }, moment(rangeDate[1]).format(formatStr))) : /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'rangeDate'
  }, /*#__PURE__*/React__default['default'].createElement("span", {
    className: 'inputDate onlyOne'
  }, moment(rangeDate).format(formatStr))), /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'rangeType'
  }, /*#__PURE__*/React__default['default'].createElement("span", null, rangeType), /*#__PURE__*/React__default['default'].createElement("span", {
    className: 'icon'
  })), show && /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'dropdown'
  }, /*#__PURE__*/React__default['default'].createElement(Calendar, {
    range: range,
    startYear: startYear,
    rangeDate: rangeDate,
    setRangeDate: setRangeDate,
    rangeType: rangeType,
    setRangeType: setRangeType,
    setShow: setShow
  }))));
};

exports.RangePicker = RangePicker;
